## hak5-wifi-coconut 1.1.0

=== CMakeLists.txt ===
# Based on the hackrf cmakefiles, in turn based on the libftdi cmake

cmake_minimum_required(VERSION 3.0)

if (MSVC)
    include_directories(getopt)
    add_definitions(/D _CRT_SECURE_NO_WARNINGS)
    if (FIND_DEBUG)
        add_definitions(/D FIND_DEBUG)
    endif()
elseif (MINGW32)
    set(CMAKE_SYSTEM_NAME Windows)
    set(TOOLCHAIN_PREFIX x86_64-w64-mingw32)
    set(CMAKE_C_COMPILER ${TOOLCHAIN_PREFIX}-gcc)
    set(CMAKE_CXX_COMPILER ${TOOLCHAIN_PREFIX}-g++)
    set(CMAKE_Fortran_COMPILER ${TOOLCHAIN_PREFIX}-gfortran)
    set(CMAKE_RC_COMPILER ${TOOLCHAIN_PREFIX}-windres)
    set(CMAKE_FIND_ROOT_PATH /usr/${TOOLCHAIN_PREFIX})
    set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
    set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
    set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static")
else()
    add_definitions(-Wall)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
    if (FIND_DEBUG)
        add_definitions(-DFIND_DEBUG=1)
    endif()
endif()

project(userspace-wifi C)
set(PACKAGE userspace-wifi)
include(${PROJECT_SOURCE_DIR}/cmake/set_release.cmake)
add_definitions(-DRELEASE="${RELEASE}")
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

set(prefix ${CMAKE_INSTALL_PREFIX})

if(MSVC)
    find_package(PThread REQUIRED)
    include_directories(${PTHREAD_INCLUDE_DIR}) 
    set(INT_THREAD_LIBS ${PTHREADS_LIBRARY})

    find_package(LibUSB-1.0 REQUIRED)
    include_directories(${LIBUSB_1_INCLUDE_DIR})
    link_directories(${LIBUSB_1_LIBRARY_DIR})
    set(INT_LIBUSB_LIBS ${LIBUSB_1_LIBRARIES})

    set (firmwaredir .)
elseif(MINGW32)
    # find_package(PThread REQUIRED)
    # include_directories(${PTHREAD_INCLUDE_DIR}) 
    # set(INT_THREAD_LIBS ${PTHREADS_LIBRARY})

    #find_package(LibUSB-1.0 REQUIRED)
    #include_directories(${LIBUSB_1_INCLUDE_DIR})
    #link_directories(${LIBUSB_1_LIBRARY_DIR})
    #set(INT_LIBUSB_LIBS ${LIBUSB_1_LIBRARIES})

    find_package(Threads REQUIRED)
    set(INT_THREAD_LIBS ${THREADS_LIBRARY})

    include_directories("${VCPKG_HOME}/installed/x64-mingw-static/include/libusb-1.0")
    set(INT_LIBUSB_LIBS "${VCPKG_HOME}/installed/x64-mingw-static/lib/libusb-1.0.a")

    set (firmwaredir .)
else()
    find_package(Threads REQUIRED)
    set(INT_THREAD_LIBS ${THREADS_LIBRARY})

    find_package(USB1 REQUIRED)
    include_directories(${LIBUSB_INCLUDE_DIR})
    set(INT_LIBUSB_LIBS ${LIBUSB_LIBRARIES})

    set (firmwaredir \${prefix}/share/wifiuserspace/firmware)

endif()


add_subdirectory(libwifiuserspace)

include_directories(${PROJECT_SOURCE_DIR}/libwifiuserspace)

SET(TOOLS
    wifi_coconut
)

if (MSVC)
    add_library(libgetopt_static STATIC
        getopt/getopt.c
    )
endif()

if (MINGW32)
    add_library(libpthread STATIC IMPORTED)
else()
    LIST(APPEND TOOLS_LINK_LIBS ${INT_THREAD_LIBS})
endif()

LIST(APPEND TOOLS_LINK_LIBS wifiuserspace-static)
LIST(APPEND TOOLS_LINK_LIBS ${INT_LIBUSB_LIBS})
LIST(APPEND TOOLS_LINK_LIBS ${CMAKE_THREAD_LIBS_INIT})

include_directories(${PROJECT_SOURCE_DIR})

if (MSVC)
    LIST(APPEND TOOLS_LINK_LIBS libgetopt_static)

    add_custom_target(copydlls)
endif()

add_executable(wifi_coconut 
    wifi_coconut.c 
    wifi_coconut/wifi_coconut.c
)

foreach(tool ${TOOLS})
    target_link_libraries(${tool} ${TOOLS_LINK_LIBS})
    install(TARGETS ${tool} RUNTIME DESTINATION bin)
endforeach(tool)

INSTALL(
    DIRECTORY ${PROJECT_SOURCE_DIR}/libwifiuserspace/firmware/
    DESTINATION ${firmwaredir}
)

=== libwifiuserspace/CMakeLists.txt ===
# Based on the hackrf cmakefiles, in turn based on the libftdi cmake

project(libwifiuserspace C)
set(PACKAGE libwifiuserspace)
include(${PROJECT_SOURCE_DIR}/../cmake/set_release.cmake)
add_definitions(-DRELEASE="${RELEASE}")
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/../cmake/modules)

if(MSVC)
    find_package(PThread REQUIRED)
    include_directories(${PTHREAD_INCLUDE_DIR}) 
    set(INT_THREAD_LIBS ${PTHREADS_LIBRARY})

    find_package(LibUSB-1.0 REQUIRED)
    include_directories(${LIBUSB_1_INCLUDE_DIR})
    link_directories(${LIBUSB_1_LIBRARY_DIR})
    set(INT_LIBUSB_LIBS ${LIBUSB_1_LIBRARIES})

    set(sharedir "./")
    set(INSTALL_LIB_DIR "./")
    set(INSTALL_DEFAULT_BINDIR "./")
elseif (MINGW32)
    #find_package(PThread REQUIRED)
    #include_directories(${PTHREAD_INCLUDE_DIR}) 
    #set(INT_THREAD_LIBS ${PTHREADS_LIBRARY})

    #find_package(LibUSB-1.0 REQUIRED)
    #include_directories(${LIBUSB_1_INCLUDE_DIR})
    #link_directories(${LIBUSB_1_LIBRARY_DIR})
    #set(INT_LIBUSB_LIBS ${LIBUSB_1_LIBRARIES})

    find_package(Threads REQUIRED)
    set(INT_THREAD_LIBS ${THREADS_LIBRARY})

    #find_package(USB1 REQUIRED)
    #include_directories(${LIBUSB_INCLUDE_DIR})
    #set(INT_LIBUSB_LIBS ${LIBUSB_LIBRARIES})
    include_directories("${VCPKG_HOME}/installed/x64-mingw-static/include/libusb-1.0")
    set(INT_LIBUSB_LIBS "${VCPKG_HOME}/installed/x64-mingw-static/lib/libusb-1.0.a")

    set(sharedir "./")
    set(INSTALL_LIB_DIR "./")
    set(INSTALL_DEFAULT_BINDIR "./")
else()
    find_package(Threads REQUIRED)
    set(INT_THREAD_LIBS ${THREADS_LIBRARY})

    find_package(USB1 REQUIRED)
    include_directories(${LIBUSB_INCLUDE_DIR})
    set(INT_LIBUSB_LIBS ${LIBUSB_LIBRARIES})
    
    set (sharedir \${prefix}/share/wifiuserspace/firmware)

    set(INSTALL_LIB_DIR \${lib}suffix)

    set(INSTALL_DEFAULT_BINDIR "bin")
endif()

add_definitions(-DFIRMWAREDIR="${prefix}/share/wifiuserspace/firmware")

set(c_sources 
    ${CMAKE_CURRENT_SOURCE_DIR}/rt2800usb/rt2800lib.c
    ${CMAKE_CURRENT_SOURCE_DIR}/rt2800usb/rt2800usb.c
    ${CMAKE_CURRENT_SOURCE_DIR}/rt2800usb/rt2x00.c
    ${CMAKE_CURRENT_SOURCE_DIR}/rt2800usb/rt2x00mac.c
    ${CMAKE_CURRENT_SOURCE_DIR}/rt2800usb/rt2x00usb.c

    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/cfg80211.c
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/crc_ccit.c

    ${CMAKE_CURRENT_SOURCE_DIR}/userspace/userspace.c

    CACHE INTERNAL "List of C sources")

set(c_kernel_headers
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/kernel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/types.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/usb.h
    CACHE INTERNAL "List of userspace-kernel headers")
set(c_userspace_headers
    ${CMAKE_CURRENT_SOURCE_DIR}/userspace/userspace.h
    CACHE INTERNAL "List of userspace API eaders")

add_library(wifiuserspace SHARED ${c_sources})
set_target_properties(wifiuserspace PROPERTIES VERSION 2019.09.0 SOVERSION 0)

add_library(wifiuserspace-static STATIC ${c_sources})
if (MSVC)
    set_target_properties(wifiuserspace-static PROPERTIES OUTPUT_NAME "wifiuserspace_static")
else()
    set_target_properties(wifiuserspace-static PROPERTIES OUTPUT_NAME "wifiuserspace")
endif()

set_target_properties(wifiuserspace PROPERTIES CLEAN_DIRECT_OUTPUT 1)
set_target_properties(wifiuserspace-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)

target_link_libraries(wifiuserspace ${INT_THREAD_LIBS} ${INT_LIBUSB_LIBS} ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(wifiuserspace-static ${INT_THREAD_LIBS} ${INT_LIBUSB_LIBS} ${CMAKE_THREAD_LIBS_INIT})


if(INSTALL_LIBUSERSPACE)
    if(MSVC)
    # Static linkage only on win32
    else()
       install(TARGETS wifiuserspace
               LIBRARY DESTINATION ${INSTALL_LIB_DIR}
               COMPONENT sharedlibs
               )
       install(TARGETS wifiuserspace-static
               ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
               COMPONENT staticlibs
               )
       install(FILES ${c_kernel_headers}
               DESTINATION include/${PROJECT_NAME}
               COMPONENT headers
               )
       install(FILES ${c_userspace_headers}
               DESTINATION include/${PROJECT_NAME}
               COMPONENT headers
               )
    endif()

    INSTALL(
        DIRECTORY ${PROJECT_SOURCE_DIR}/firmware/
        DESTINATION ${sharedir}
    )
endif(INSTALL_LIBUSERSPACE)

include_directories(${PROJECT_SOURCE_DIR})

=== debian/changelog ===
hak5-wifi-coconut (1.1.0-0kali2) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * Add superficial test
  * Update Maintainer field
  * Update Vcs-* fields
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Add Uploaders
  * Set upstream metadata fields Repository, Repository-Browse.
  * Add hardening flag
  * We don't need to set hardening flags
  * Add patch to deal with debug and fortifying sources
  * Fix firmware licensing in d/copyright
  * Add bindnow hardening flag

  [ Arnaud Rebillout ]
  * Update dependency: firmware-misc-nonfree -> firmware-mediatek

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 24 Sep 2024 20:57:51 +0700

hak5-wifi-coconut (1.1.0-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Steev Klimaszewski <steev@kali.org>  Tue, 08 Nov 2022 14:42:02 -0600

=== debian/control ===
Source: hak5-wifi-coconut
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders:
 Steev Klimaszewski <steev@kali.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-cmake,
 libusb-1.0-0-dev,
 pkgconf,
Standards-Version: 4.6.1
Homepage: https://hak5.org
Vcs-Browser: https://gitlab.com/kalilinux/packages/hak5-wifi-coconut
Vcs-Git: https://gitlab.com/kalilinux/packages/hak5-wifi-coconut.git
Rules-Requires-Root: no

Package: hak5-wifi-coconut
Architecture: any
Depends:
 firmware-mediatek,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Userspace driver for the Hak5 Wi-Fi Coconut
 Userspace drive for USB Wi-Fi NICs and the Hak5 Wi-Fi Coconut

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ --buildsystem=cmake

=== debian/tests/control ===
Test-Command: wifi_coconut -h
Restrictions: superficial

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/hak5-wifi-coconut-$1\.tar\.gz/ \
  https://github.com/hak5/hak5-wifi-coconut/tags .*/v?(\d\S*)\.tar\.gz
